package easss.step4;

import cartago.*;
import java.math.BigDecimal;

public class Env extends Artifact {

	private Display display;
	private boolean locked;
	
    void init() {
    	this.defineObsProperty("numMsg",0);
    	display = new Display();
    	display.setVisible(true);
    	locked = false;
    	System.out.println("Env ready.");
	}
    
    @OPERATION void printMsg(String msg){
    	String agentName = this.getOpUserName();
    	ObsProperty prop = this.getObsProperty("numMsg");
    	prop.updateValue(prop.intValue()+1);
    	display.addText("Message from "+agentName+": "+msg);
    	display.updateNumMsgField(prop.intValue());
    }
    
    @OPERATION void computePi(int numDigits, OpFeedbackParam<String> res){
    	BigDecimal digits = CalcLib.computePiDigits(numDigits);
    	res.set(digits.toPlainString());
    }
    
    @OPERATION void lock(){
    	await("notLocked");
    	locked = true;
    }

    @GUARD boolean notLocked(){
    	return !locked;
    }
    
    @OPERATION void unlock(){
    	locked = false;
    }
    
}



